/*------------------------------------------------*/
/* Clustering				                      */
/* Filename   : Clustering.cpp                    */
/*------------------------------------------------*/

#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <vector>
#include <conio.h>

#include "pslib.h"
#include "GroupInfo.h"
#include "Point.h"

using std::vector;
typedef vector<CPoint> INTVECTOR;

int LoadFileData(char *filename); // Load coordinates data
void FindBoundaryPoint(float *minX, float *minY, float *maxX, float *maxY, int pointCount); // Find the 4 points that will be consist the boundary line.
void DrawBoundaryLine(cPSLib *pMyps, int pointCount); // Draw the Boundary Line
void SetInitialGroupInfo(int groupNo, int pointNo); // Set the GroupInfo
bool CheckTheClusterDiameter(int groupCount, int pointCount, float limitDistance); // Check the limit diameter per cluster
CPoint pointData[30000];
CGroupInfo groupData[500];
//vector<CPoint> pointData;

int main(int argc, char **argv)
{
	if (argc != 3) // check the number of arguments
	{
		cout << "Usage: cluster filename size\n";
		exit(0);
	}

	int pointCount = LoadFileData(argv[1]); // Load Input File
	int groupCount = 1; // The Number of Group
	float clusterDistance = atof(argv[2]); // Load the Cluster Maximum Distance
	int i, j, k; // Iterator 
	float distMy, distOpp; // distance variables between a point and a centroid
	int flag, stepCount = 0; // flag variable that check the point's moving
//	INTVECTOR::iterator iterator, iterator2;
//	time_t t;
//	srand(time(&t)); // Generate the random value, every time.
//	int randomValue;

	cPSLib myps("test.ps"); // Load a PostScript file
	printf("- Loaded test.ps file -\n"); // Load test.ps file

	DrawBoundaryLine(&myps, pointCount);

	while(1)
	{
		printf("Now Clustering - The Step : %d\n", ++stepCount);
/*
		for(i = 0; i < pointCount; i++) //   Ư ŬͿ ϰ ԽŰ
		{
			randomValue = rand() % groupCount;
			pointData[i].SetGroupNumber(randomValue);
		}
*/
		for(i = 0; i < pointCount; i++) // contain each object to the specific cluster
			pointData[i].SetGroupNumber(i % groupCount);

		SetInitialGroupInfo(groupCount, pointCount); // Set Initial Group Information

		while(1)
		{
			flag = 0; // Loop Flag (check the point's moving) 0 means 'not moving'
			
///////////////////////////////////////////////////////////////////////////////
/*                                 START                                     */
/*                       K-Means Clustering Algorithm                        */
///////////////////////////////////////////////////////////////////////////////
			for(i = 0; i < groupCount; i++)
			{
//			    for (theIterator = vCluster[i].begin(); theIterator != vCluster[i].end(); theIterator++)
				for(j = 0; j < groupCount; j++)
				{
					if(i == j) // Don't need to compare between same cluster data.
						continue;

					for(int m = 0; m < pointCount; m++)
					{						
						if(pointData[m].GetGroupNumber() == i)
						{
							distMy = (pointData[m].GetPositionX() - groupData[i].GetCentroidX()) * // calculate the distance between specific point included group[i] and group[i]'s centroid
									(pointData[m].GetPositionX() - groupData[i].GetCentroidX()) +
									(pointData[m].GetPositionY() - groupData[i].GetCentroidY()) *
									(pointData[m].GetPositionY() - groupData[i].GetCentroidY());
							distOpp = (pointData[m].GetPositionX() - groupData[j].GetCentroidX()) * // calculate the distance between specific point included group[j] and group[i]'s centroid
								    (pointData[m].GetPositionX() - groupData[j].GetCentroidX()) +
									(pointData[m].GetPositionY() - groupData[j].GetCentroidY()) *
									(pointData[m].GetPositionY() - groupData[j].GetCentroidY());

							if(distMy >= distOpp) // move the point to other cluster from current cluster
							{   // update the information changing
								groupData[i].m_pointCount--; // Change the total point number of each cluster
								groupData[j].m_pointCount++;
	
								groupData[i].m_totalX -= pointData[m].GetPositionX(); 
								groupData[i].m_totalY -= pointData[m].GetPositionY(); 
								groupData[i].SetCentroidX(groupData[i].m_totalX / groupData[i].m_pointCount); // Recalculate the centroid of cluster[i]
								groupData[i].SetCentroidY(groupData[i].m_totalY / groupData[i].m_pointCount); 
	
								groupData[j].m_totalX += pointData[m].GetPositionX(); 
								groupData[j].m_totalY += pointData[m].GetPositionY(); 
								groupData[j].SetCentroidX(groupData[j].m_totalX / groupData[j].m_pointCount); // Recalculate the centroid of cluster[j]
								groupData[j].SetCentroidY(groupData[j].m_totalY / groupData[j].m_pointCount);

								pointData[m].SetGroupNumber(j);	// change the current point's group					
								flag++; // flag - there is change between clusters
							}
						}

						else if(pointData[m].GetGroupNumber() == j)
						{
							distMy = (pointData[m].GetPositionX() - groupData[j].GetCentroidX()) * // calculate the distance between specific point included group[j] and group[j]'s centroid
								 	(pointData[m].GetPositionX() - groupData[j].GetCentroidX()) + 
									(pointData[m].GetPositionY() - groupData[j].GetCentroidY()) *
									(pointData[m].GetPositionY() - groupData[j].GetCentroidY());
							distOpp = (pointData[m].GetPositionX() - groupData[i].GetCentroidX()) * // calculate the distance between specific point included group[j] and group[i]'s centroid
									(pointData[m].GetPositionX() - groupData[i].GetCentroidX()) + 
									(pointData[m].GetPositionY() - groupData[i].GetCentroidY()) *
									(pointData[m].GetPositionY() - groupData[i].GetCentroidY());

							if(distMy >= distOpp) // move the point to other cluster from current cluster
							{   // update the information changing
								groupData[j].m_pointCount--;
								groupData[i].m_pointCount++;
	
								groupData[j].m_totalX -= pointData[m].GetPositionX();
								groupData[j].m_totalY -= pointData[m].GetPositionY();
								groupData[j].SetCentroidX(groupData[j].m_totalX / groupData[j].m_pointCount);
								groupData[j].SetCentroidY(groupData[j].m_totalY / groupData[j].m_pointCount);
	
								groupData[i].m_totalX += pointData[m].GetPositionX();
								groupData[i].m_totalY += pointData[m].GetPositionY();
								groupData[i].SetCentroidX(groupData[i].m_totalX / groupData[i].m_pointCount);
								groupData[i].SetCentroidY(groupData[i].m_totalY / groupData[i].m_pointCount);
	
								pointData[m].SetGroupNumber(i);	// change the current point's group							
								flag++;
							}
						}
					}
				}
			}

			if(flag == 0) // There is no moving point
				break;
		}
///////////////////////////////////////////////////////////////////////////////
/*                       K-Means Clustering Algorithm                        */
/*                                  END                                      */
///////////////////////////////////////////////////////////////////////////////

		if(CheckTheClusterDiameter(groupCount, pointCount, clusterDistance) == 1) // Check the limited diameter
		{
			printf("- Complete the K-Means Calculation -\n");
			break;
		}
		else
			groupCount += 3; // Next Step [K++ -Means]

		if(groupCount > 70)
			break;
	}

	printf("- Drawing points - \n");

	for(i = 0; i < pointCount; i++) // Draw all points at the plane coordinates
		myps.DrawCircle(pointData[i].GetPositionX(), pointData[i].GetPositionY(), 0.1f, 1, 1.0f, 0.0f);

///////////////////////////////////////////////////
/*       Drawing Outlines of all clusters        */
///////////////////////////////////////////////////
	printf("- Drawing the cluster's outlines - \n");

	double angle = 0, gradient, radian;
	float optimalAngle = 0; // it is angle to find the best boundary point
	int clusterSize; // each cluster's size
	float minInitX, minInitY, maxInitX, maxInitY; // To draw the boundary of cluster, Save the start point of the line.
	float X[5000], Y[5000];
	float oldX, oldY, newX, newY; // These are start point & end point for drawing a boundary line.
	float resultAngle;

	for(k = 0; k < groupCount; k++)
	{
		clusterSize = 0;
		minInitY = 99999;
		maxInitY = 0;

		for(i = 0; i < pointCount; i++)  
		{
			if(pointData[i].GetGroupNumber() == k) // Extract specific group(cluster[k])'s point from the point array
			{
				X[clusterSize] = pointData[i].GetPositionX();
				Y[clusterSize] = pointData[i].GetPositionY();
				clusterSize++;
			}
		}

		for(i = 0; i < clusterSize; i++)
		{
			if(Y[i] <= minInitY) // Find the point that has a minimum X in k cluster's points
			{
				minInitY = Y[i];
				minInitX = X[i];
			}

			if(Y[i] >= maxInitY) // Find the point that has a minimum Y in k cluster's points
			{
				maxInitY = Y[i];
				maxInitX = X[i];
			}
		}

		// Draw the boundar line of each cluster [STEP 1 : BOTTOM-UP]
		oldX = minInitX, oldY = minInitY;

		for(j = 0; j < clusterSize; j++)
		{
			optimalAngle = 999; // initial angle value (the initial angle value is bigger than 360

			for(i = 0; i < clusterSize; i++)
			{
				if(oldX == X[i] && oldY == Y[i])
					continue;

				if(X[i] != oldX) // if denominator is not zero
				{   // Calculate the angle for gradient
					gradient = (Y[i] - oldY) / (X[i] - oldX); // compute the gradient
					angle = atan(gradient); // compute the angle
					radian = angle * (180/3.141592);
				}

				if(X[i] == oldX) // if denominator is zero
				{
					if(Y[i] > oldY) // considering the Y(positive or negative number), revise the angle
						resultAngle = 90.0;
					else
						resultAngle = 270.0;
				}
				else
				{   // revise the angle
					if(X[i] >= oldX && Y[i] >= oldY) // a point included the first coordinates
						resultAngle = radian;
					else if(X[i] <= oldX && Y[i] >= oldY) // a point included the second coordinates 
						resultAngle = 90 + (90 + radian);
					else if(X[i] <= oldX && Y[i] <= oldY) // a point included the third coordinates
						resultAngle = 180 + radian;
					else // a point included the fourth coordinates
						resultAngle = 270 + (90 + radian);
				}

				if(optimalAngle >= resultAngle) // find the point that has smaller angle than current minimum angle
				{
					newX = X[i], newY = Y[i];
					optimalAngle = resultAngle;
				}
			}
		
			myps.DrawLine(oldX, oldY, newX, newY, 0.1f); // draw the cluster's boundary line(point to point).

			oldX = newX, oldY = newY;
	
			if(oldX == maxInitX && oldY == maxInitY) // If current point meets the maximum init point, the algorithm ends
				break;
		}

		// Draw the boundar line of each cluster [STEP 2 : TOP-DOWN]
		oldX = maxInitX, oldY = maxInitY;

		for(j = 0; j < clusterSize; j++)
		{
			optimalAngle = 999; // initial angle value (the initial angle value is bigger than 360

			for(i = 0; i < clusterSize; i++)
			{
				if(oldX == X[i] && oldY == Y[i])
					continue;

				if(X[i] != oldX) // if denominator is not zero
				{
					gradient = (Y[i] - oldY) / (X[i] - oldX);
					angle = atan(gradient);
					radian = angle * (180/3.141592);
				}

				if(X[i] == oldX) // if denominator is zero
				{
					if(Y[i] > oldY) // considering the Y(positive or negative number), revise the angle
						resultAngle = 270.0;
					else
						resultAngle = 90.0;
				}
				else
				{
					if(X[i] <= oldX && Y[i] <= oldY) // a point included the third coordinates
						resultAngle = radian;
					else if(X[i] >= oldX && Y[i] <= oldY) // a point included the fourth coordinates 
						resultAngle = 90 + (90 + radian);
					else if(X[i] >= oldX && Y[i] >= oldY) // a point included the first coordinates
						resultAngle = 180 + radian;
					else // a point included the second coordinates
						resultAngle = 270 + (90 + radian);
				}

				if(optimalAngle >= resultAngle) // find the point that has smaller angle than current minimum angle
				{
					newX = X[i], newY = Y[i];
					optimalAngle = resultAngle;
				}
			}
		
			myps.DrawLine(oldX, oldY, newX, newY, 0.1f); // draw the cluster's boundary line(point to point).

			oldX = newX, oldY = newY;

			if(oldX == minInitX && oldY == minInitY) // If current point meets the minimum init point, the algorithm ends
				break;
		}	
	}

	printf("- Drawing the centroid point - \n");
	for(i = 0; i < groupCount; i++) // Draw the Centroid position of each cluster
		myps.DrawCircle(groupData[i].GetCentroidX(), groupData[i].GetCentroidY(), 1.0f, 1); 
	
	myps.CloseFile(); // Close the PS file

	printf("- Finished -\n");

	return 0;
}

int LoadFileData(char *filename)
{
	FILE *pFile = fopen(filename, "r");
	float posX, posY; 
	int count = 0;

	while(1) 
	{
		if(fscanf(pFile, "%f %f", &posX, &posY) == EOF) // Read the coordinates data
			break;

		pointData[count++].SetPosition(posX, posY); // save the coordinates data to the point array
	}

	printf("Loaded filename : %s\n", filename);
	printf("Point coordinate count : %d count\n\n", count);

	return count;
}

void FindBoundaryPoint(float *minX, float *minY, float *maxX, float *maxY, int pointCount)
{
	float minXTemp, minYTemp, maxXTemp, maxYTemp;
	minXTemp = pointData[0].GetPositionX();
	minYTemp = pointData[0].GetPositionY();
	maxXTemp = pointData[0].GetPositionX();
	maxYTemp = pointData[0].GetPositionY();

	for(int i = 1; i < pointCount; i++)
	{
		if(pointData[i].GetPositionX() <= minXTemp) // Find the point that has a minimum x value
			minXTemp = pointData[i].GetPositionX();

		if(pointData[i].GetPositionX() >= maxXTemp) // Find the point that has a maximum x value
			maxXTemp = pointData[i].GetPositionX();
		
		if(pointData[i].GetPositionY() <= minYTemp) // Find the point that has a minimum y value
			minYTemp = pointData[i].GetPositionY();
		
		if(pointData[i].GetPositionY() >= maxYTemp) // Find the point that has a maximum y value
			maxYTemp = pointData[i].GetPositionY();
	}

	*minX = minXTemp;
	*minY = minYTemp;
	*maxX = maxXTemp;
	*maxY = maxYTemp;
}

void SetInitialGroupInfo(int groupNo, int pointNo)
{
	float totalXpos, totalYpos;
	int totalPointInGroup;
	int i, j;

	for(i = 0; i < groupNo; i++)
	{
		totalXpos = totalYpos = 0.0;
		totalPointInGroup = 0;
	
		for(j = 0; j < pointNo; j++)
		{
			if(i == pointData[j].GetGroupNumber()) 
			{
				totalXpos += pointData[j].GetPositionX(); // Compute the total x length of points included i cluster
				totalYpos += pointData[j].GetPositionY(); // Compute the total x length of points included i cluster
				totalPointInGroup++;
			}
		}

		groupData[i].SetCentroidX(totalXpos / totalPointInGroup);
		groupData[i].SetCentroidY(totalYpos / totalPointInGroup);
		groupData[i].m_totalX = totalXpos;
		groupData[i].m_totalY = totalYpos;
		groupData[i].m_pointCount = totalPointInGroup;
	}
}

bool CheckTheClusterDiameter(int groupCount, int pointCount, float limitDistance)
{
	float distance, nLimit;
	int i, j;

	for(i = 0; i < pointCount; i++)
	{
		for(j = 0; j < groupCount; j++)
		{
			if(pointData[i].GetGroupNumber() == j)
			{   // calculate the distance between the centrold and other points that included same cluster.
				distance = /*sqrt(*/(pointData[i].GetPositionX() - groupData[j].GetCentroidX()) * // getting more speed, i remove the sqrt calculation
								(pointData[i].GetPositionX() - groupData[j].GetCentroidX()) +     // instead, I add the nLimit variable and operations.
								(pointData[i].GetPositionY() - groupData[j].GetCentroidY()) *
								(pointData[i].GetPositionY() - groupData[j].GetCentroidY())/*)*/;
	
				nLimit = (limitDistance/2) * (limitDistance/2); // Limit Distance

				if(nLimit < distance) // if the cluster's diameter is exceed the limited distance
					return false; // false
			}
		}
	}

	return true; // true
}

void DrawBoundaryLine(cPSLib *pMyps, int pointCount)
{
	float minX, minY, maxX, maxY; // The Boundary Point

	FindBoundaryPoint(&minX, &minY, &maxX, &maxY, pointCount); // Find the points that form the boundary.
	
	pMyps->FitA4(minX-10, minY-10, maxX+10, maxY+10); // fit the regions to A4

	// bounding box
	float boundaryX[4], boundaryY[4];  // Assign the boundary point to the array for drawing boundary lines.
	boundaryX[0] = minX, boundaryY[0] = minY; 
	boundaryX[1] = minX, boundaryY[1] = maxY; 
	boundaryX[2] = maxX, boundaryY[2] = maxY; 
	boundaryX[3] = maxX, boundaryY[3] = minY; 

	pMyps->DrawPolygon(boundaryX, boundaryY, 4, 0, 1.0f); // Draw Boundary Lines

	printf("- Drew the boundary lines -\n"); 
}