// GroupInfo.cpp: implementation of the CGroupInfo class.
//
//////////////////////////////////////////////////////////////////////

#include "GroupInfo.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CGroupInfo::CGroupInfo()
{

}

CGroupInfo::CGroupInfo(CPoint centroid, CPoint total, int pointCount)
{
	// Initialize the group information
	m_centroidX = centroid.GetPositionX();
	m_centroidY = centroid.GetPositionY();

	m_totalX = total.GetPositionX();
	m_totalY = total.GetPositionY();

	m_pointCount = pointCount;
}

CGroupInfo::~CGroupInfo()
{

}

CPoint CGroupInfo::ComputeTheCentroid()
{
	CPoint point;
	
	point.SetPositionX(m_totalX / m_pointCount); // update the new centroid coordinates
	point.SetPositionY(m_totalY / m_pointCount);

	return point;
}

void CGroupInfo::SetCentroidX(float x)
{
	m_centroidX = x;
}

void CGroupInfo::SetCentroidY(float y)
{
	m_centroidY = y;
}

float CGroupInfo::GetCentroidX()
{
	return m_centroidX;
}

float CGroupInfo::GetCentroidY()
{
	return m_centroidY;
}

void CGroupInfo::SetTotalX(float totalX)
{
	m_totalX = totalX;
}

float CGroupInfo::GetTotalX()
{
	return m_totalX;
}

void CGroupInfo::SetTotalY(float totalY)
{
	m_totalY = totalY;
}

float CGroupInfo::GetTotalY()
{
	return m_totalY;
}
