// GroupInfo.h: interface for the CGroupInfo class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GROUPINFO_H__9E71579B_FEBD_4872_ABBA_EB1AC957D130__INCLUDED_)
#define AFX_GROUPINFO_H__9E71579B_FEBD_4872_ABBA_EB1AC957D130__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Point.h"

class CGroupInfo  
{
private:
	float m_centroidX; // Centroid Coordinates : X position
	float m_centroidY; // Centroid Coordinates : Y position

public:
	// I declared following 3 variables as a public member for fast execution speed.
	float m_totalX; // The Total X length of points that are included this cluster
	float m_totalY; // The Total Y length of points that are included this cluster
	int m_pointCount;

	float GetTotalY(); // Get sum of Y length
	void SetTotalY(float totalY); // Set sum of Y length
	float GetTotalX(); // get sum of X length
	void SetTotalX(float totalX); // Set sum of Y length
	float GetCentroidY(); // get centroid x
	float GetCentroidX(); // get centroid y
	void SetCentroidY(float y); // set centroid y
	void SetCentroidX(float x); // set centroid x
	CPoint ComputeTheCentroid(); // Compute the centroid coordinate

	CGroupInfo();
	CGroupInfo(CPoint centroid, CPoint total, int pointCount);
	virtual ~CGroupInfo();

};

#endif // !defined(AFX_GROUPINFO_H__9E71579B_FEBD_4872_ABBA_EB1AC957D130__INCLUDED_)
