#ifndef _PSLIB_H_
#define _PSLIB_H_

#include <stdio.h>

#define A4WIDTH		595.0f
#define A4HEIGHT	842.0f

class cPSLib
{
	char m_FileName[100];			// postscript file name
   	FILE *m_Fp; 					// file pointer

public:

	// constructors
	cPSLib(); 
	cPSLib(char *FileName); 

	// accessor functions
	char *GetFileName(); 
	FILE *GetFilePointer();

	// utility functions
	void OpenFile(char *FileName); 
	void CloseFile(); 

	// drawing functions
	void DrawLine(float x1, float y1, float x2, float y2, 
				  float width=1.0f, float color=0.0f);
	void DrawCircle(float cx, float cy, float radius, 
				    int fill=0, float width=1.0f, float color=0.0f); 
	void DrawText(float x, float y, char *Text, int Scale=12, 
				  float color=0.0f);
	void DrawPolygon(float *, float *, int npoints, int fill=0,
		             float width=1.0f, float color=0.0f); 

	// zooming functions
	void FitA4(float minx, float miny, float maxx, float maxy);
}; 

#endif